## fsl 5.0.9

=== src/fabber/Makefile ===
include ${FSLCONFDIR}/default.mk

PROJNAME = fabber

USRINCFLAGS = -I${INC_NEWMAT} -I${INC_PROB} -I${INC_BOOST} -D__OXASL
#USRINCFLAGS = -I${INC_NEWMAT} -I${INC_PROB} -I${INC_BOOST} -D__OXASL -D__FABBER_LIBRARYONLY
#USRINCFLAGS = -I${INC_NEWMAT} -I${INC_PROB} -I${INC_BOOST} -D__OXASL -D__FABBER_LIBRARYONLY -D__FABBER_LIBRARYONLY_TESTWITHNEWIMAGE
USRLDFLAGS = -L${LIB_NEWMAT} -L${LIB_PROB}

#LIBS = -lutils -lprob -lnewmat # Will report the MISCMATHS dependencies
#LIBS = -lutils -lmiscmaths -lprob -lnewmat -lfslio -lniftiio -lznz -lz 
LIBS = -lutils -lnewimage -lmiscmaths -lprob -lnewmat -lfslio -lniftiio -lznz -lz 

XFILES = fabber mvntool



OBJS = fwdmodel_custom.o fwdmodel_flobs.o tools.o fwdmodel_q2tips.o inference_spatialvb.o dataset.o inference_vb.o noisemodel.o noisemodel_white.o fwdmodel_quipss2.o fwdmodel_pcASL.o fwdmodel.o fwdmodel_simple.o fwdmodel_linear.o noisemodel_ar.o inference.o dist_mvn.o easylog.o easyoptions.o fwdmodel_asl_grase.o fwdmodel_asl_buxton.o inference_nlls.o fwdmodel_asl_pvc.o  fwdmodel_asl_satrecov.o fwdmodel_asl_quasar.o fwdmodel_cest.o fwdmodel_dsc.o

# For debugging:
OPTFLAGS = -ggdb
#OPTFLAGS =

all:	${XFILES}

fabber: ${OBJS} fabber.o
	${CXX}  ${CXXFLAGS} ${LDFLAGS} -o $@ ${OBJS} fabber.o ${LIBS}

mvntool: ${OBJS} mvntool.o
	${CXX}  ${CXXFLAGS} ${LDFLAGS} -o $@ ${OBJS} mvntool.o ${LIBS}

#fabber_library: $(OBJS}
	#${CXX}  ${CXXFLAGS} ${LDFLAGS} -D__FABBER_LIBRARYONLY -o $@ ${OBJS} fabber.o ${LIBS}
	#${CXX}  ${CXXFLAGS} ${LDFLAGS} -D__FABBER_LIBRARYONLY -o $@ ${OBJS} mvntool.o ${LIBS}

SCRIPTS = fabber_var

# DO NOT DELETE

=== src/fdt/Makefile ===
include $(FSLCONFDIR)/default.mk

ifeq ($(COMPILE_GPU), 1)
	COMPILE_WITH_GPU=libbedpostx_cuda.so merge_parts_gpu xfibres_gpu CUDA/split_parts_gpu
	SCRIPTS_GPU=CUDA/bedpostx_gpu CUDA/bedpostx_postproc_gpu.sh
endif

PROJNAME = fdt

USRINCFLAGS = -I${INC_NEWMAT} -I${INC_NEWRAN} -I${INC_CPROB} -I${INC_PROB} -I${INC_BOOST} -I${INC_ZLIB}
USRLDFLAGS = -L${LIB_NEWMAT} -L${LIB_NEWRAN} -L${LIB_CPROB} -L${LIB_PROB} -L${LIB_ZLIB}

DLIBS = -lwarpfns -lbasisfield -lmeshclass -lnewimage -lutils -lmiscmaths -lnewmat -lnewran -lfslio -lniftiio -lznz -lcprob -lprob -lm -lz

DTIFIT=dtifit
CCOPS=ccops
PTX=probtrackx
MED=medianfilter
ROM=reord_OM
SAUS=sausages
XFIBRES=xfibres
XFIBRES2=xfibres_2
RV=replacevols
MDV=make_dyadic_vectors
FMO=fdt_matrix_ops
INDEXER=indexer
TEST=testfile
VECREG=vecreg
KURTOSIS=kurtosis
SWAPDYADS=swap_dyadic_vectors
PVMFIT=pvmfit
DTIGEN=dtigen
BASGEN=basgen
RARNG=rearrange
XPRED=xfibres_pred
RUBIX=rubix
RBXPRED=rubix_pred
EDDYCOMBINE=eddy_combine
LIBBEDPOSTX_CUDA=libbedpostx_cuda.so
MERGE_PARTS_GPU=merge_parts_gpu
SPLIT_PARTS_GPU=CUDA/split_parts_gpu
XFIBRES_GPU=xfibres_gpu

DTIFITOBJS=dtifit.o dtifitOptions.o diffmodels.o Bingham_Watson_approx.o
CCOPSOBJS=ccops.o ccopsOptions.o
PTXOBJS=probtrackx.o probtrackxOptions.o streamlines.o ptx_simple.o ptx_seedmask.o ptx_twomasks.o ptx_nmasks.o ptx_meshmask.o
MEDOBJS=medianfilter.o 
ROMOBJS=reord_OM.o
SAUSOBJS=sausages.o
XFIBOBJS=xfibres.o xfibresoptions.o diffmodels.o Bingham_Watson_approx.o 
XFIBOBJS2=xfibres_2.o xfibresoptions.o
RVOBJS=replacevols.o
MDVOBJS=make_dyadic_vectors.o
FMOOBJS=fdt_matrix_ops.o
INDEXEROBJS=indexer.o
TESTOBJS=testfile.o 
VECREGOBJS=vecreg.o
KURTOSISOBJS=kurtosis.o dtifitOptions.o
SWAPDYADSOBJS=swap_dyadic_vectors.o
PVMFITOBJS=pvmfit.o pvmfitOptions.o diffmodels.o Bingham_Watson_approx.o
DTIGENOBJS=dtigen.o
BASGENOBJS=basgen.o diffmodels.o Bingham_Watson_approx.o
RARNGOBJS=rearrange.o
XPREDOBJS=xfibres_pred.o
RUBIXOBJS=rubix.o diffmodels.o rubixvox.o rubixoptions.o Bingham_Watson_approx.o
RBXPREDOBJS=rubix_pred.o
EDDYCOMBINEOBJS=eddy_combine.o
MERGE_PARTS_GPUOBJS=merge_parts_gpu.o xfibresoptions.o
SPLIT_PARTS_GPUOBJS=CUDA/split_parts_gpu.o
XFIBRES_GPUOBJS=xfibres_gpu.o xfibresoptions.o diffmodels.o Bingham_Watson_approx.o

SGEBEDPOST = bedpost 
SGEBEDPOSTX = bedpostx bedpostx_postproc.sh bedpostx_preproc.sh bedpostx_single_slice.sh bedpostx_datacheck

SCRIPTS = eddy_correct zeropad maskdyads probtrack fdt_rotate_bvecs select_dwi_vols ${SGEBEDPOST} ${SGEBEDPOSTX} ${SCRIPTS_GPU}
FSCRIPTS = correct_and_average ocmr_preproc

XFILES = dtifit ccops medianfilter make_dyadic_vectors vecreg xfibres probtrackx pvmfit dtigen eddy_combine ${COMPILE_WITH_GPU}

FXFILES = reord_OM sausages replacevols fdt_matrix_ops indexer rearrange xfibres_pred


RUNTCLS = Fdt

all: ${XFILES} ${FXFILES} 

${PTX}:		   ${PTXOBJS}
		   ${CXX} ${CXXFLAGS} ${LDFLAGS} -o $@ ${PTXOBJS} ${DLIBS}

${PT}:		   ${PTOBJS}
		   ${CXX} ${CXXFLAGS} ${LDFLAGS} -o $@ ${PTOBJS} ${DLIBS} 

${FTB}:    	${FTBOBJS}
		   ${CXX} ${CXXFLAGS} ${LDFLAGS} -o $@ ${FTBOBJS} ${DLIBS} 

${PJ}:    	${PJOBJS}
		   ${CXX} ${CXXFLAGS} ${LDFLAGS} -o $@ ${PJOBJS} ${DLIBS} 

${MED}:    	${MEDOBJS}
		   ${CXX} ${CXXFLAGS} ${LDFLAGS} -o $@ ${MEDOBJS} ${DLIBS} 

${DTIFIT}:    	${DTIFITOBJS}
		   ${CXX} ${CXXFLAGS} ${LDFLAGS} -o $@ ${DTIFITOBJS} ${DLIBS}

${CCOPS}:    	${CCOPSOBJS}	
		   ${CXX} ${CXXFLAGS} ${LDFLAGS} -o $@ ${CCOPSOBJS} ${DLIBS}

${ROM}:    	${ROMOBJS}
		   ${CXX} ${CXXFLAGS} ${LDFLAGS} -o $@ ${ROMOBJS} ${DLIBS}

${SAUS}:    	${SAUSOBJS}
		   ${CXX} ${CXXFLAGS} ${LDFLAGS} -o $@ ${SAUSOBJS} ${DLIBS}

${XFIBRES}:    	${XFIBOBJS}
		   ${CXX} ${CXXFLAGS} ${LDFLAGS} -o $@ ${XFIBOBJS} ${DLIBS}

${XFIBRES2}:    	${XFIBOBJS2}
		   ${CXX} ${CXXFLAGS} ${LDFLAGS} -o $@ ${XFIBOBJS2} ${DLIBS}

${RV}:    	${RVOBJS}
		   ${CXX} ${CXXFLAGS} ${LDFLAGS} -o $@ ${RVOBJS} ${DLIBS}

${MDV}:    	${MDVOBJS}
		   ${CXX} ${CXXFLAGS} ${LDFLAGS} -o $@ ${MDVOBJS} ${DLIBS}

${FMO}:    	${FMOOBJS}
		   ${CXX} ${CXXFLAGS} ${LDFLAGS} -o $@ ${FMOOBJS} ${DLIBS}

${INDEXER}:    	${INDEXEROBJS}
		   ${CXX} ${CXXFLAGS} ${LDFLAGS} -o $@ ${INDEXEROBJS} ${DLIBS}

${TEST}:    	${TESTOBJS}
		   ${CXX} ${CXXFLAGS} ${LDFLAGS} -o $@ ${TESTOBJS} ${DLIBS}

${VECREG}:    	${VECREGOBJS}
		   ${CXX} ${CXXFLAGS} ${LDFLAGS} -o $@ ${VECREGOBJS} ${DLIBS}


${KURTOSIS}:   ${KURTOSISOBJS}
		   ${CXX} ${CXXFLAGS} ${LDFLAGS} -o $@ ${KURTOSISOBJS} ${DLIBS}

${SWAPDYADS}: ${SWAPDYADSOBJS}
		   ${CXX} ${CXXFLAGS} ${LDFLAGS} -o $@ ${SWAPDYADSOBJS} ${DLIBS}

${PVMFIT}:    	${PVMFITOBJS}
		   ${CXX} ${CXXFLAGS} ${LDFLAGS} -o $@ ${PVMFITOBJS} ${DLIBS}

${DTIGEN}:    	${DTIGENOBJS}
		   ${CXX} ${CXXFLAGS} ${LDFLAGS} -o $@ ${DTIGENOBJS} ${DLIBS}

${BASGEN}:    	${BASGENOBJS}
		   ${CXX} ${CXXFLAGS} ${LDFLAGS} -o $@ ${BASGENOBJS} ${DLIBS}

${RARNG}: 	${RARNGOBJS}
		   ${CXX} ${CXXFLAGS} ${LDFLAGS} -o $@ ${RARNGOBJS} ${DLIBS}

${XPRED}: 	${XPREDOBJS}
		   ${CXX} ${CXXFLAGS} ${LDFLAGS} -o $@ ${XPREDOBJS} ${DLIBS}

${RUBIX}: 	${RUBIXOBJS}
		   ${CXX} ${CXXFLAGS} ${LDFLAGS} -o $@ ${RUBIXOBJS} ${DLIBS}

${RBXPRED}: 	${RBXPREDOBJS}
		   ${CXX} ${CXXFLAGS} ${LDFLAGS} -o $@ ${RBXPREDOBJS} ${DLIBS}

${EDDYCOMBINE}: ${EDDYCOMBINEOBJS}
		   ${CXX} ${CXXFLAGS} ${LDFLAGS} -o $@ ${EDDYCOMBINEOBJS} ${DLIBS}

${LIBBEDPOSTX_CUDA}: 
		${CUDA}/bin/nvcc --shared --compiler-options '-fPIC' -o CUDA/libbedpostx_cuda.so CUDA/init_gpu.cu CUDA/samples.cu CUDA/diffmodels.cu CUDA/runmcmc.cu  CUDA/xfibres_gpu.cu -O3  -gencode=arch=compute_20,code=\"sm_20,compute_20\" -gencode=arch=compute_30,code=\"sm_30,compute_30\" -gencode=arch=compute_35,code=\"sm_35,compute_35\" -gencode=arch=compute_50,code=\"sm_50,compute_50\" -lcudart -lcuda -lcurand -I. -L${CUDA}/lib64 -L${CUDA}/lib -ICUDA/options -I${CUDA}/include/thrust -I${FSLDIR}/extras/include/newmat -I${FSLDIR}/include -I${FSLDIR}/extras/include/boost -maxrregcount=64
		@if [ ! -d ${FSLDEVDIR}/lib/ ] ; then ${MKDIR} ${FSLDEVDIR}/lib ; fi
		${CP} -rf CUDA/libbedpostx_cuda.so ${FSLDEVDIR}/lib

${MERGE_PARTS_GPU}: ${MERGE_PARTS_GPUOBJS}
		   ${CXX} ${CXXFLAGS} ${LDFLAGS} -o $@ ${MERGE_PARTS_GPUOBJS} ${DLIBS}

${SPLIT_PARTS_GPU}: ${SPLIT_PARTS_GPUOBJS}
		   ${CXX} ${CXXFLAGS} ${LDFLAGS} -o $@ ${SPLIT_PARTS_GPUOBJS} ${DLIBS}

${XFIBRES_GPU}: ${XFIBRES_GPUOBJS}
		   ${CXX} ${CXXFLAGS} ${LDFLAGS} -o $@ ${XFIBRES_GPUOBJS} ${DLIBS} -lcudart -lcuda -lcurand -lbedpostx_cuda -LCUDA -L${CUDA}/lib64 -L${CUDA}/lib

=== src/miscmaths/Makefile ===
# A Makefile for the miscmaths class

include ${FSLCONFDIR}/default.mk

PROJNAME = miscmaths

USRINCFLAGS = -I${INC_NEWMAT} -I${INC_BOOST} -I${INC_PROB}
USRLDFLAGS = -L${LIB_NEWMAT} -L${LIB_PROB}

OBJS = miscmaths.o optimise.o miscprob.o kernel.o histogram.o base2z.o t2z.o f2z.o minimize.o cspline.o sparse_matrix.o sparsefn.o rungekutta.o nonlin.o bfmatrix.o Simplex.o

LIBS = -lutils -lnewmat -lprob -lm

# The target "all" should ALWAYS be provided
#   typically it will just be another target name

all: libmiscmaths.a

quick:${OBJS} quick.o
	${CXX}  ${CXXFLAGS} ${LDFLAGS} -o $@ ${OBJS} quick.o ${LIBS}

libmiscmaths.a: ${OBJS}
	${AR} -r libmiscmaths.a ${OBJS}

=== src/verbena/Makefile ===
include ${FSLCONFDIR}/default.mk

PROJNAME = verbena

SCRIPTS = verbena

all:

=== debian/changelog ===
fsl (5.0.9-2~nd15.10+1) wily; urgency=medium

  * Backported for wily.
  * Used following sed expression to modify debian/control: -e
    's/\(^Depends:\) */\1 neurodebian-popularity-contest, /g' -e
    's/^Maintainer:.*$/Maintainer: NeuroDebian Maintainers
    <team@neuro.debian.net>\nX-Original-&/'.

 -- NeuroDebian Maintainers <team@neuro.debian.net>  Fri, 18 Dec 2015 01:12:25 -0500

fsl (5.0.9-2) neurodebian; urgency=medium

  * debian/fsl.sh - place FSL's bin path first (not the last) within adjusted
    $PATH (Closes: #804881)

 -- Yaroslav Halchenko <debian@onerussian.com>  Sun, 13 Dec 2015 21:31:21 -0500

fsl (5.0.9-1) neurodebian; urgency=medium

  * New upstream release.
    - Initial release of Verbena -- model-based analysis of perfusion from
      DSC-MRI based on a vascular model
    - randomise has much improved handling of voxelwise regressors
    - dtifit has now the option for correcting for gradient non-linearities
      unhidden
    - select_dwi_vols allows quick extraction of a certain b-shell from DWI
      data
    - bedpostx has a new model, where instead of using a stick kernel to
      represent a fibre compartment, a “zeppelin” axially symmetric tensor
      can be used
    - and more
  * 'eddy' is no longer built as the sources aren't included in the upstream
    release anymore. A new 'fsl-5.0-eddy-nonfree' package is now recommened
    tha provides 'eddy'.

 -- Michael Hanke <mih@debian.org>  Fri, 09 Oct 2015 08:15:48 +0200

=== debian/control ===
Source: fsl
Maintainer: NeuroDebian Team <team@neuro.debian.net>
Uploaders: Michael Hanke <mih@debian.org>,
           Yaroslav Halchenko <debian@onerussian.com>
Section: non-free/science
XS-Autobuild: yes
Priority: optional
Build-Depends: debhelper (>= 7),
               zlib1g-dev,
               libboost-dev,
               libpng-dev,
               libgd-dev,
               libnewmat10-dev,
               libgdchart-gd2-noxpm-dev | libgdchart-gd2-xpm-dev,
               liboctave-dev | octave3.2-headers | octave3.0-headers,
               tcl,
               imagemagick,
               libnifti-dev,
               libgiftiio-dev,
               mesa-common-dev,
               libexpat1-dev | libexpat-dev,
               libglu1-mesa-dev | libglu-dev,
               libgomp1
Standards-Version: 3.9.6
Vcs-Browser: https://anonscm.debian.org/cgit/pkg-exppsy/fsl.git
Vcs-Git: git://anonscm.debian.org/pkg-exppsy/fsl.git
Homepage: http://www.fmrib.ox.ac.uk/fsl/

Package: fsl
Architecture: all
Section: non-free/oldlibs
Depends: fsl-core,
         ${misc:Depends}
Description: transitional dummy package
 The only purpose of this package is to enable upgrades to the new 'fsl-core'
 package which replaces 'fsl'. This package can safely be removed.
 .
 Users aiming to perform a complete FSL installation (including all data
 components) are advised to install the 'fsl-complete' package from
 NeuroDebian.

Package: fsl-5.0
Architecture: all
Section: non-free/oldlibs
Depends: fsl-5.0-core,
         ${misc:Depends}
Description: transitional dummy package
 The only purpose of this package is to enable upgrades to the new
 'fsl-5.0-core' package which replaces 'fsl-5.0'.
 This package can safely be removed.
 .
 Users aiming to perform a complete FSL 5.0 installation (including
 all data components) are advised to install the 'fsl-5.0-complete'
 package from NeuroDebian.

Package: fsl-core
Architecture: all
Depends: fsl-5.0-core,
         ${misc:Depends}
Breaks: fsl (<< 5.0.3)
Replaces: fsl (<< 5.0.3)
Description: metapackage for the latest version of FSL
 FSL is a comprehensive library of image analysis and statistical tools
 for fMRI, MRI and DTI brain imaging data. The suite consists of various
 command line tools, as well as simple GUIs for its core analysis pipelines.
 Among others, FSL offers implementations of standard GLM analysis,
 white matter tractography, tissue segmentation, affine and non-linear
 co-registration, and independent component analysis.
 .
 Some FSL components require additional data packages (fsl-atlases,
 fsl-first-data, fsl-possum-data) that are currently available from the
 NeuroDebian repository only. For more information on how to obtain these
 data packages visit http://neuro.debian.net.
 .
 Users aiming to perform a complete FSL installation (including
 all data components) are advised to install the 'fsl-complete'
 package from NeuroDebian.

Package: fsl-5.0-core
Architecture: any
Depends: mozilla-firefox | www-browser,
         tcsh | c-shell,
         tk,
         tcl,
         bc,
         dc,
         python,
         fslview,
         libjs-excanvas,
         ${shlibs:Depends},
         ${misc:Depends}
Recommends: fsl-atlases,
          fsl-5.0-eddy-nonfree,
Suggests: fsl-feeds,
          fsl-5.0-gpu,
          octave | ${octave:Depends},
          mriconvert | dicomnifti,
          fsl-complete,
          condor | gridengine-client
Breaks: fsl-5.0 (<< 5.0.3)
Conflicts: fsl-fslview,
           fsl-doc-4.1 (<< 4.1.9-5~)
Provides: fsl
Replaces: fsl-5.0 (<< 5.0.3)
Description: analysis tools for FMRI, MRI and DTI brain imaging
 FSL is a comprehensive library of image analysis and statistical tools
 for fMRI, MRI and DTI brain imaging data. The suite consists of various
 command line tools, as well as simple GUIs for its core analysis pipelines.
 Among others, FSL offers implementations of standard GLM analysis,
 white matter tractography, tissue segmentation, affine and non-linear
 co-registration, and independent component analysis.
 .
 Some FSL components require additional data packages (fsl-atlases,
 fsl-first-data, fsl-possum-data) that are currently available from the
 NeuroDebian repository only. For more information on how to obtain these
 data packages visit http://neuro.debian.net.
 .
 Users aiming to perform a complete FSL 5.0 installation (including
 all data components) are advised to install the 'fsl-5.0-complete'
 package from NeuroDebian.
 .
 FSL interoperates well with other brain imaging related software. This includes
 Caret, FreeSurfer (cortical flattening and modelling). All FSL tools support
 the NIfTI format.

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-

FSLMAJORVERSION = 5.0

# enable exented globbing in the shell to be able to use more
# sophisticated stuff in dh_install files
SHELL := /bin/bash -O extglob

# get octave paths (have to build-depend on octave-headers)
include /usr/share/octave/debian/defs.make

# This has to be exported to make some magic below work.
export DH_OPTIONS

# specify all FSL projects that shall be built
PROJECTS = \
  utils fslio miscmaths newimage libvis first_lib meshclass fslvtkio \
  misc_tcl basisfield warpfns bint shapeModel MVdisc fslsurface libmeshutils \
  avwutils basil bet2 cluster fast4 feat5 film filmbabe flirt fabber baycest \
  fslvbm mcflirt melodic misc_c miscvis mm gps randomise siena slicetimer susan \
  tbss fnirt fugue asl_mfree misc_scripts fdt first possum sgeutils flameo \
  oxford_asl qboot topup ptx2 lesions verbena

# specify FSL extras to be built
EXTRAS = libprob libcprob cprob

# set essential config vars for FSL build process
FSLDIR=$(CURDIR)
FSLCONFDIR=$(FSLDIR)/config

# apply to FSL as 'ARCHLDFLAGS'
# 'as-needed' kills everything -- symbols of C libs get confused
# and results change -- remember cprob:gamma()
#LDFLAGS = -Wl,--no-undefined -Wl,--as-needed -L/usr/lib/fsl/lib
LDFLAGS:=$(shell dpkg-buildflags --get LDFLAGS) \
         -Wl,--no-undefined -L/usr/lib/fsl/lib
# default compiler flags
# apply to FSL as 'ANSI_FLAGS'
CFLAGS:=$(shell dpkg-buildflags --get CFLAGS) \
        $(shell dpkg-buildflags --get CPPFLAGS) \
        -DHAVE_LIBFREETYPE -fPIC \
        -I/usr/include/nifti \
        -I/usr/include/gifti \
        -I/usr/include/newmat \
        -I$(FSLDIR)/extras/src/libprob -I$(FSLDIR)/extras/src/libcprob \
        -I$(FSLDIR)/src

# where are the internal libs
FSL_LIBRARY_PATH=$(CURDIR)/lib

# install into this directory
DEB_DESTDIR=$(CURDIR)/debian/tmp

# don't compile GPU
COMPILE_GPU:=0

# define common environment setup for all make calls
# complicated LD_LIBRARY expression ensures that no
# trailing colon ends up in LD_LIBRARY_PATH
DEB_BUILD_ENV=LD_LIBRARY_PATH=$(FSL_LIBRARY_PATH)$${LD_LIBRARY_PATH:+:$${LD_LIBRARY_PATH}} \
		FSLDIR="$(FSLDIR)" \
		FSLDEVDIR="$(FSLDIR)" \
		FSLCONFDIR="$(FSLCONFDIR)" \
		DEB_DESTDIR="$(DEB_DESTDIR)" \
		OPTFLAGS="$(OPTFLAGS)" \
		ANSI_FLAGS="$(CFLAGS) $(CPPFLAGS)" \
		DEPENDFLAGS="$(CFLAGS)" \
		ARCHLDFLAGS="$(LDFLAGS)" \
		COMPILE_GPU="$(COMPILE_GPU)" \
		CUDA="/usr"

controlfiles:
	# inject current FSL major version into all templates
	for f in debian/templates/*; do \
		sed -e "s/#FSLMVERSION#/$(FSLMAJORVERSION)/g" $$f \
			> debian/$$(basename $$f) ; \
	done
	# renamed files that need to have a version-specific name
	for suffix in 1 desktop dirs install links lintian-overrides manpages menu docs; do \
		for prefix in 'core' 'gpu'; do \
		[ -f debian/fsl-$$prefix.$$suffix ] &&  \
			mv debian/fsl-$$prefix.$$suffix debian/fsl-$(FSLMAJORVERSION)-$$prefix.$$suffix || true ; \
		done ; \
	done
	# and rename the meta-package files
	for f in debian/meta.*; do \
		target=$$(basename $$f); suffix=$${target#*.} ; \
		mv $$f debian/fsl-core.$$suffix; \
	done

cleancontrolfiles:
	# clean sed'ed files and intermediate rubbish
	for f in debian/templates/*; do\
		rm -f debian/$$(basename $$f) ; \
	done
	rm -f debian/fsl-core.preinst
	# versioned files
	rm -f debian/fsl-$(FSLMAJORVERSION)-{core,gpu}.{1,desktop,dirs,install,links,lintian-overrides,manpages,menu,preinst,docs}

# build and install extra
biextra-%:
	$(DEB_BUILD_ENV) $(MAKE) -C extras/src/$*
	$(DEB_BUILD_ENV) $(MAKE) -C extras/src/$* install

# cleanup extra
cextra-%:
	$(DEB_BUILD_ENV) $(MAKE) -C extras/src/$* distclean

# build and install sub-project
biproj-%:
	$(DEB_BUILD_ENV) $(MAKE) -C src/$*
	$(DEB_BUILD_ENV) $(MAKE) -C src/$* install

# cleanup sub-project
cproj-%:
	$(DEB_BUILD_ENV) $(MAKE) -C src/$* distclean

# build and install all extras
biextras: $(EXTRAS:%=biextra-%)

# clean all extras
cextras: $(EXTRAS:%=cextra-%)
	find extras/src -name '*.o' -delete


instdir:
# FSL does not separate build and install properly
# create temporary install dir now
	if [ ! -d $(DEB_DESTDIR) ]; then mkdir -p $(DEB_DESTDIR); fi
	dh_installdirs

# build and install all sub-projects
biprojs: $(PROJECTS:%=biproj-%)

# cleanup all sub-projects
cprojs: $(PROJECTS:%=cproj-%)


#Architecture
build: build-arch build-indep
build-arch: build-stamp
build-indep: build-stamp
build-stamp: instdir biextras biprojs
	dh_testdir

	# fix permissions
	find debian/tmp/tcl/BWidget -type f -exec chmod -x {} \;
	chmod 644 debian/tmp/tcl/*.{tcl,xbm,ppm,ico}
	chmod -x debian/tmp/etc/flirtsch/*

	# cleanup TCL stuff
	rm -r debian/tmp/tcl/BWidget/BWMan/
	find debian/tmp/tcl/BWidget/ -name '*.txt' -delete

	# generate debhelper file to create /usr/bin symlinks and manpage links
	# for all relevant binaries installed by the versioned FSL package
	for f in $$(find debian/tmp/bin \! -type d \! -name Runtcl | sort); do \
		bname=$$(basename $$f); \
		[[ "$$bname" = *gpu* ]] && ptype="gpu" || ptype="core" ; \
		echo "/usr/lib/fsl/$(FSLMAJORVERSION)/fsl_app_wrapper /usr/bin/fsl$(FSLMAJORVERSION)-$$bname" >> debian/fsl-$(FSLMAJORVERSION)-$$ptype.links ; \
		echo "/usr/share/man/man1/fsl-$(FSLMAJORVERSION).1.gz /usr/share/man/man1/fsl$(FSLMAJORVERSION)-$${bname}.1.gz" >> debian/fsl-$(FSLMAJORVERSION)-$$ptype.links ; \
	done
	touch $@


clean: cleancontrolfiles controlfiles cextras cprojs
	dh_testdir
	dh_testroot

	# remove leftovers
	find $(CURDIR) -name '*.so' -delete
	-rm src/fdt/{xfibres,fdt_matrix_ops,indexer,replacevols,probtrackx,reord_OM,sausages,probtrack_old,xfibres_pred,rearrange}
	-rm src/feat5/doc/{top.html,feat.tcl}
	-rm -r etc/standard lib

	# clean the remaining temp dir
	rm -rf include

	# finally clean package
	dh_clean

	# fix permissions in the source
	find src/ -name '*.fig' -or -name '*.gif' -exec chmod -x {} \;

	-rm build-stamp


# checks that the included desktop files are ok
validate-desktop-files:
	for f in $(CURDIR)/debian/desktop/*.desktop; do \
		desktop-file-validate $${f} ; \
	done


install: build
	# make FSL logo for menu entries
	convert debian/tmp/tcl/fsl-logo-tiny.ppm \
		-resize x32 -crop 32x32+6+0 debian/tmp/fsl-$(FSLMAJORVERSION).xpm

	# install fsl config
	cp -r -t debian/tmp etc
	# clean useless pieces
	rm debian/tmp/etc/fslconf/fslmachtype.sh
	# do not install license files
	rm debian/tmp/etc/js/LICENSE.txt
	# comes in an dedicated package
	rm debian/tmp/etc/js/excanvas.js



# Must not depend on anything. This is to be called by
# binary-arch/binary-indep
# in another 'make' thread.
binary-common:
	dh_testdir
	dh_testroot
	dh_install
	dh_installchangelogs
	dh_installman
	dh_installdocs
	dh_installmenu
	# fixup duplicate GPU tools
	rm -f debian/fsl-$(FSLMAJORVERSION)-core/usr/lib/fsl/$(FSLMAJORVERSION)/*gpu*
	rm -f debian/fsl-$(FSLMAJORVERSION)-core/usr/lib/fsl/$(FSLMAJORVERSION)/*cuda*
	dh_lintian
	dh_link
	dh_strip
	dh_compress
	dh_fixperms
	dh_installdeb
	# dh_shlibdeps needs access to the private libs
	dh_shlibdeps -l $(FSL_LIBRARY_PATH)
	# get the correct dependency for older octave
	[ -e /usr/bin/octave-depends ] \
        && octave-depends || true
	dh_gencontrol
	dh_md5sums
	dh_builddeb


# Build architecture independent packages using the common target.
binary-indep: install
	dh_installdirs -i

	$(MAKE) -f debian/rules DH_OPTIONS=-i binary-common


# Build architecture dependant packages using the common target.
binary-arch: install
	dh_installdirs -a

	# install the stylesheet
	cp -r doc/fsl.css debian/fsl-$(FSLMAJORVERSION)-core/usr/share/fsl/$(FSLMAJORVERSION)/doc

	# remove previous link to make repeated builds work
	-rm debian/fsl-$(FSLMAJORVERSION)-core/usr/share/fsl/$(FSLMAJORVERSION)/etc/fslconf/{feat.tcl,fsl.sh}

	# set execute permission for GUI application wrapper
	chmod +x debian/fsl_app_wrapper

	$(MAKE) -f debian/rules DH_OPTIONS=-a binary-common


binary: binary-arch binary-indep
.PHONY: build clean binary-indep binary-arch binary
